<template>
  <div class="w-100 pru">
    <template v-if="phase=='showDetail'">
      <book-detail :book="bookSelected" :serverId="server.id" @close="phase='showinBooks'"></book-detail>
    </template>
    <template v-else>
      <nav class="navbar navbar-light mb-5 mt-0 w-100" style="background-color: #e3f2fd;">

        <div class="btn-group btn-group-toggle" :class="{'d-none':hiddeFilters}" data-toggle="buttons">
          <label class="btn btn-secondary active" data-container="html" data-toggle="popover" data-trigger="hover" data-placement="auto" data-content="Ascending-order" @click="revert('asc')">
            <input type="radio" name="order" id="order" value="ascending" v-model="order">
            <font-awesome-icon color="white" icon="sort-amount-up"/>
          </label>
          <label class="btn btn-secondary" data-toggle="popover" data-trigger="hover" data-placement="auto" data-content="Descending-order" @click="revert('desc')">
            <input type="radio" name="order" id="order" value="descending" v-model="order">
            <font-awesome-icon color="white" icon="sort-amount-down"/>
          </label>
        </div>
        <div class="btn-group btn-group-toggle" :class="{'d-none':hiddeFilters}" data-toggle="buttons">
          <label class="btn btn-secondary active" data-toggle="popover" data-trigger="hover" data-placement="auto" data-content="All" @click="readfilter('all')">
            <input type="radio" value="showall">
            <font-awesome-icon color="white" icon="eye"/>
          </label>
          <label class="btn btn-secondary" data-content="Readed" data-toggle="popover" data-trigger="hover" data-placement="auto" @click="readfilter('readed')">
            <input type="radio" value="showreaded">
            <font-awesome-icon color="green" icon="eye"/>
          </label>
          <label class="btn btn-secondary" data-toggle="popover" data-trigger="hover" data-placement="auto" data-content="Reading" @click="readfilter('reading')">
            <input type="radio" value="shownotreaded">
            <font-awesome-icon color="yellow" icon="eye"/>
          </label>
          <label class="btn btn-secondary" data-toggle="popover" data-trigger="hover" data-placement="auto" data-content="Not Readed" @click="readfilter('notreaded')">
            <input type="radio" value="shownotreaded">
            <font-awesome-icon color="firebrick" icon="eye"/>
          </label>
        </div>
        <div class="btn-group btn-group-toggle" :class="{'d-none':hiddeFilters}" data-toggle="buttons">
          <label class="btn btn-secondary active" data-toggle="popover" data-trigger="hover" data-placement="auto" data-content="Title" @click="filterapply('title')">
            <input type="radio" name="orderby" id="orderby" value="title">
            <font-awesome-icon color="white" icon="book"/>
          </label>
          <label class="btn btn-secondary" data-toggle="popover" data-trigger="hover" data-placement="auto" data-content="Author" @click="filterapply('author')">
            <input type="radio" name="orderby" id="orderby" value="author">
            <font-awesome-icon color="white" icon="pen-fancy"/>
          </label>
        </div>

        <form class="form-inline my-2 my-lg-0 text-white">
          <div class="input-group">
            <div class="input-group-prepend bg-secondary d-flex align-items-center justify-content-center pl-2 pr-2">
              <font-awesome-icon class="fa-lg" data-toggle="popover" data-trigger="hover" data-placement="auto" data-content="Search" color="white" icon="search"/>
            </div>
            <input
              class="form-control mr-sm-2 bg-secondary text-white"
              v-model="textfilter"
              type="search"
              placeholder="Title or Author"
              aria-label="Search"
              @keyup="filterbytext('','')"
            >
          </div>
        </form>
      </nav>

    <div class="row d-flex justify-content-around align-items-start h-100">
      <template v-if="phase==='showinBooks'" >
        <div
          v-for="(book, key) in books"
          class="m-1 book"
          :serverId="server.id"
          v-show="filterbytext(book.title,book.author)"
          :key="key "
        >
          <book
            class="d-flex"
            @toggleRead="toggleRead(book._id)"
            @updateBookProgress="data=>updateBook(data)"
            v-bind:book="book"
            :progress="readingBooks[book._id]||0" :serverId="server.id"
            @bookDetail="(book)=>showingDetail(book)">
          </book>
        </div>
      </template>
      <div v-if="phase==='noBooks'" class="align-self-center ml-auto mr-auto ">
         <div class="card mt-5 d-flex justify-content-center bg-transparent border-0">
           <span class="mt-2" style="font-size:3vh"><font-awesome-icon class="card-img-top" color="black" size="10x" icon="book-dead"/></span>
          <div class="card-body">
            <h3 class="card-text">No books at</h3>
            <h3> {{library.name}}</h3>
          </div>
        </div>
      </div>
      <div class="align-self-center mt-0 p-0">
        <loader v-if="phase=='loading'"></loader>
      </div>
    </div>
  </template>
  </div>
</template>
<script>
const $ = require("jquery");
var _ = require("lodash");
import book from "./Book";
import bookDetail from "./BookDetail"
import EventBus from "../../main";
import loader from "./Loader";
import { isNullOrUndefined } from "util";
export default {
  name: "bookArea",
  props: ["server", "library","hiddeFilters"],
  components: {
    book,
    loader,
    bookDetail
  },
  data() {
    return {
      user: JSON.parse(localStorage.getItem("user")),
      token: localStorage.getItem("jwt"),
      books: [],
      readingBooks:{},
      order: "asc",
      orderby: "title",
      textfilter: "",
      phase: "loading",
      bookSelected:null,
      booksfilterless: [],
    };
  },

  mounted: function() {

    EventBus.$on("waitingBooksResponse", () => {
      this.phase = "loading";
    });
    this.$socket.on('resDeleteValoration',data=>{
      this.updateBookValoration(data.bookId,data.newValoration)
    })
    this.$socket.on('resBookComment',data=>{
      this.updateBookValoration(data.bookId,data.newValoration)
    })
    this.$socket.on("resBooks server " + this.server.id, response => {
      if (!isNullOrUndefined(response.books) && response.books.length != 0) {
        this.books = response.books;
        this.booksfilterless=response.books
          if(response.reads){
            response.reads.forEach(read => {
                this.$set(this.readingBooks,read.ebookId,read.readed)
            });
          }
        this.phase = "showinBooks";
      } else{

        this.phase = "noBooks";
      }
    });

    this.$socket.on("newBook server " + this.server.id, data => {
      this.$toastr.info(
        "the book " +
          data.newBook.title +
          " has added to server " +
          this.server.name +
          "at library : " +
          data.libraries[0].name,
        "Book added",
        {
          preventDuplicates: true,
          progressBar: true,
          positionClass: 'toast-bottom-right',
        }
      );
      data.libraries.forEach(library => {
        if (this.library._id == data.libraries[0]._id && !this.books.includes(data.newBook)) {
          this.books.push(data.newBook);
          return true
        }
      });
    });

    this.$socket.on("deletedBook server " + this.server.id, data => {
      this.$toastr.error(
        "the book " +
          data.book.title +
          " has deleted in server " +
          this.server.name,
        "Book deleted" + "of library : " + data.libraries[0].name,
        {
          preventDuplicates: true,
          progressBar: true,
          positionClass: 'toast-bottom-right',
        }
      );

        if (this.library._id == data.libraries[0]._id) {
          this.books.forEach(book=>{
            if(book._id==data.book._id){
              this.books.splice(this.books.indexOf(book),1);
              return true
            }
          })

        }
    });
  },
  methods: {
    updateBookValoration(bookId,newValoration) {
      this.books.forEach(book=>{
        if(bookId==book._id){
          this.$set(book, 'valoration', newValoration)
          return true
        }
      })
    },
    filterapply(orderby) {

      this.books = _.orderBy(this.books, [orderby]);
      this.orderby = orderby;
      this.revert(this.order);
    },
    revert(order) {
      if (order == "desc")
        this.books = _.orderBy(this.books, this.orderby, "desc");
      else this.books = _.orderBy(this.books, this.orderby, "asc");
      this.order = order;
    },
    readfilter(filter) {
      switch (filter) {
        case "readed":
          this.books=_.filter(this.booksfilterless, (o)=> {
            if(this.readingBooks[o._id]==100) return o;
          });
          break;
        case "notreaded":
          this.books=_.filter(this.booksfilterless, (o)=> {
            if(this.readingBooks[o._id]==null) return o;
          });
          break;
        case "reading":
          this.books=_.filter(this.booksfilterless, (o)=> {
            if(this.readingBooks[o._id]<100 && this.readingBooks[o._id]>0) return o;
          });
          break;
        default:
          this.books = this.booksfilterless;
      }
    },
    filterbytext(title, author) {
      if (
        title.toUpperCase().includes(this.textfilter.toUpperCase()) ||
        author.toUpperCase().includes(this.textfilter.toUpperCase())
      )
        return true;
    },
    showingDetail(book){
      this.bookSelected=book
      this.phase='showDetail'
    },
    toggleRead(bookId) {
      if(this.readingBooks[bookId]!=100) this.$set(this.readingBooks,bookId,100)
      else this.$set(this.readingBooks,bookId,0)
        EventBus.$emit("updateBookProgress"+bookId,this.readingBooks[bookId])
      },
    updateBook(data){
       this.$set(this.readingBooks,data.bookId,data.progress)
    }
  }
};
</script>
<style scoped>
  .pru{
    height: 100%;
  }

.form-control::-webkit-input-placeholder { color: white; opacity: 0.4;}  /* WebKit, Blink, Edge */
.form-control:-moz-placeholder { color: white; opacity: 0.4;}  /* Mozilla Firefox 4 to 18 */
.form-control::-moz-placeholder { color: white; opacity: 0.4;}  /* Mozilla Firefox 19+ */
.form-control:-ms-input-placeholder { color: white; opacity: 0.4;}  /* Internet Explorer 10-11 */
.form-control::-ms-input-placeholder { color: white; opacity: 0.4;}  /* Microsoft Edge */


@media (min-width: 576px) {
  .book{
    width: 60%;
  }
 }
@media (min-width: 768px) {
  .book{
    width: 25%;
  }
 }
@media (min-width: 992px) {
  .book{
    width: 15%;
    max-width: 140px;
  }
 }
@media (min-width: 1200px) {
  .book{
    width: 15%;
    max-width: 140px;
  }
 }

</style>


